//
//  LetterCounts.swift
//  words3
//
//  Created by Pete Keleher on 10/19/21.
//

import Foundation

struct LetterCounts : Comparable {
    static func < (lhs: LetterCounts, rhs: LetterCounts) -> Bool {
        var lessThan = false
        
        for (k,lv) in lhs.counts {
            if let rv = rhs.counts[k] {
                if lv > rv {
                    return false
                }
                if lv < rv {
                    lessThan = true
                }
            } else {
                return false
            }
        }
        
        for (k,_) in rhs.counts {
            if lhs.counts[k] == nil {
                lessThan = true
            }
        }
        return lessThan
    }
    
    var counts = [String:Int]()
    
    init(_ s: String) {
        for c in s {
            let s2 = String(c)
            counts[s2] = (counts[s2] ?? 0) + 1
        }
    }
}
